/******************************************************************************
 * C-BUNG 02        
 * Rechnen im Integer-Bereich und Ein- und Ausgabe an der Konsole 
 *           
 * (c) 2003, by Andreas Schibilla
 *****************************************************************************/

#include <stdio.h>

#include "ueb02.h"

#define minimum(count, werte) minmax(count, werte, 1);
#define maximum(count, werte) minmax(count, werte, 0);

/******************************************************************************
 * Berechnet Minimum oder Maximum 
 *
 * -> count    - Wieviele Werte werden bergeben
 * -> werte    - Zeiger auf Array mit den Werten als Strings
 * -> ismin    - 1=Minimum berechnen, 0=Maximum berechnen
 *           
 * Die Fkt. gibt das Minimum/Maximum als Dez.-Wert zurck
 *****************************************************************************/
int minmax(int count, char * werte[], short ismin)
{
 int i, tmp, m;

 sscanf(werte[1], "%d", &m);        /* initialisiere mit ersten Param */
 for (i=2; i<count; i++)            /* durchlaufe alle brigen Paramter */
 {
   sscanf(werte[i], "%d", &tmp);    /* char -> int */
   
   if ( ismin && (tmp < m) )        /* Ist neues Minimum */
      m = tmp;
   else
   if (!ismin && (tmp > m) )        /* Ist neues Maximum */
      m = tmp;
 }

 return m;
}


/******************************************************************************
 * Gibt eine Fehlermeldung aus
 *           
 * Die Fkt. gibt den Fehlercode 1 zurck
 *****************************************************************************/
int ShowError(void)
{
  printf(C_ERROR);
  return 1;
}


/******************************************************************************
 * Hauptfkt. berechnet Mi. und Max. und Differenz und zeigt diese an
 *
 * -> argc     - Wieviele Paramter
 * -> argv     - Array mit den Kommandozeilenparamtern als Strings
 *           
 * Die Fkt. gibt Returncode an Betriebssystem zurck
 *****************************************************************************/
int main (int argc, char *argv[])
{
 int min, max;

 if (argc < 2)                      /* keine Parameter -> Error */
      return ShowError();

 min = minimum(argc, argv);
 max = maximum(argc, argv);
 printf("Minimum: %d\nMaximum: %d\nWertespanne: %d\n", min, max, max-min);

 return 0;
}

